diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
index bb2701a04..8adef102e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
@@ -20,14 +20,15 @@ public class BlockLogicLeavesOak extends BlockLogicLeavesBase {
         if (rand.nextInt(128) == 0 && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves) {
             TilePos queryPos = new TilePos();
             for (int q = -1; q > -16; q--) {
-                int id = world.getBlockId(tilePos.add(0, q, 0, queryPos));
-                if (id != 0) break;
-                if (Blocks.LAYER_LEAVES_OAK.canPlaceAt(world, tilePos.add(0, q, 0, queryPos)) &&
-                    Blocks.blocksList[world.getBlockId(tilePos.add(0, q - 1, 0, queryPos))].getMaterial().blocksMotion()) {
-
-                    world.setBlockIdNotify(tilePos.add(0, q, 0, queryPos), Blocks.LAYER_LEAVES_OAK.id());
+                final @NotNull Block<?> block = world.getBlockType(tilePos.add(0, q, 0, queryPos));
+                if (block != Blocks.AIR) break;
+                if (
+                    Blocks.LAYER_LEAVES_OAK.canPlaceAt(world, tilePos.add(0, q, 0, queryPos)) &&
+                    world.getBlockType(tilePos.add(0, q - 1, 0, queryPos)).getMaterial().blocksMotion()
+                ) {
+                    world.setBlockTypeNotify(tilePos.add(0, q, 0, queryPos), Blocks.LAYER_LEAVES_OAK);
                     break;
-                } else if (world.getBlockId(tilePos.add(0, q, 0, queryPos)) == Blocks.LAYER_LEAVES_OAK.id()) {
+                } else if (world.getBlockType(tilePos.add(0, q, 0, queryPos)) == Blocks.LAYER_LEAVES_OAK) {
                     Blocks.LAYER_LEAVES_OAK.getLogic().accumulate(world, queryPos);
                     break;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
index 4b89587b4..d0a5d984c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
@@ -116,7 +116,7 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
 
         if (rotation == -1) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         } else {
             world.setBlockDataNotify(tilePos, rotation | (isPowered ? MASK_POWERED : 0));
         }
@@ -162,14 +162,14 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
 
         if (rotation == -1) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         } else {
             world.setBlockDataNotify(tilePos, rotation | (isPowered ? MASK_POWERED : 0));
         }
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (checkIfAttachedToBlock(world, tilePos)) {
             int rotation = getRotation(world.getBlockData(tilePos));
             boolean shouldBreak = switch (rotation) {
@@ -183,7 +183,7 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
             };
             if (shouldBreak) {
                 dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-                world.setBlockIdNotify(tilePos, 0);
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
             }
         }
     }
@@ -193,7 +193,7 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
             return true;
         } else {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
             return false;
         }
     }
@@ -237,17 +237,17 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
 
         world.markBlocksDirty(tilePos, tilePos);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, isPowered(meta) ? 0.5F : 0.6F);
-        world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
+        world.notifyBlocksOfNeighborChange(tilePos, this.block);
 
         TilePos queryPos = new TilePos();
         switch (rotation) {
-            case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block.id());
-            case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block.id());
-            case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block.id());
-            case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block.id());
+            case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block);
+            case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block);
+            case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block);
+            case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block);
             case ROTATION_TOP_NS, ROTATION_TOP_WE ->
-                world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block.id());
-            default -> world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
+            default -> world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
         }
     }
 
@@ -259,17 +259,17 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
     @Override
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         if (isPowered(data)) {
-            world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
             TilePos queryPos = new TilePos();
             int rotation = getRotation(data);
             switch (rotation) {
-                case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block.id());
-                case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block.id());
-                case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block.id());
-                case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block.id());
+                case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block);
+                case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block);
+                case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block);
+                case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block);
                 case ROTATION_TOP_NS, ROTATION_TOP_WE ->
-                    world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block.id());
-                default -> world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
+                default -> world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
             }
         }
         super.onRemoved(world, tilePos, data);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
index 601e58431..495b14a2e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
@@ -21,7 +21,7 @@ public class BlockLogicLog extends BlockLogicAxisAligned {
             for (queryPos.x = tilePos.x() - r; queryPos.x <= tilePos.x() + r; queryPos.x++) {
                 for (queryPos.y = tilePos.x() - r; queryPos.y <= tilePos.y() + r; queryPos.y++) {
                     for (queryPos.z = -tilePos.x() - r; queryPos.z <= tilePos.z() + r; queryPos.z++) {
-                        Block<?> block = world.getBlock(queryPos);
+                        Block<?> block = world.getBlockType(queryPos);
                         if (!(block != null && block.getLogic() instanceof BlockLogicLeavesBase)) {
                             continue;
                         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
index 091c26f98..b1ce19e16 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
@@ -41,24 +41,24 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
         Axis axis = mob.getPlacementDirection(side, PlacementMode.FACING).getAxis();
 
         world.setBlockDataNotify(tilePos, axisToMeta(axis));
-        world.scheduleBlockUpdate(tilePos, id(), tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
-        world.scheduleBlockUpdate(tilePos, id(), tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     @Override
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         super.onPlacedOnSide(world, tilePos, side, xHit, yHit);
-        world.scheduleBlockUpdate(tilePos, id(), tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
-        world.scheduleBlockUpdate(tilePos, id(), tickDelay());
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     public void updateState(@NotNull World world, @NotNull TilePosc tilePos) {
@@ -84,17 +84,17 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
 
 
         boolean backMatchesFront;
-        Block<?> fBlock = world.getBlock(front);
+        Block<?> fBlock = world.getBlockType(front);
         if (fBlock == null) {
-            backMatchesFront = world.getBlock(back) == null;
+            backMatchesFront = world.getBlockType(back) == null;
         } else {
             backMatchesFront = fBlock.isEquivalent(world, front, back);
         }
 
         if (!this.isActive && backMatchesFront) {
-            world.setBlockIdDataNotify(tilePos, Blocks.MATCHER_ACTIVE.id(), world.getBlockData(tilePos));
+            world.setBlockTypeDataNotify(tilePos, Blocks.MATCHER_ACTIVE, world.getBlockData(tilePos));
         } else if (this.isActive && !backMatchesFront) {
-            world.setBlockIdDataNotify(tilePos, Blocks.MATCHER.id(), world.getBlockData(tilePos));
+            world.setBlockTypeDataNotify(tilePos, Blocks.MATCHER, world.getBlockData(tilePos));
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
index 3e52c5c49..db9199595 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
@@ -23,7 +23,7 @@ public class BlockLogicMeshGold extends BlockLogicMesh {
         if (world.getTileEntity(tilePos) instanceof TileEntityMeshGold meshGold) {
             ItemStack heldItem = player.getHeldItem();
             boolean flag = meshGold.setFilterItem(player, heldItem);
-            world.notifyBlocksOfNeighborChange(tilePos, id());
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
             if(heldItem != null && heldItem.stackSize <= 0) {
                 player.inventory.setItem(player.inventory.getCurrentSlot(), null);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index d96ef8f25..54cd8e48f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -39,9 +39,9 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
                 Direction rDir = Direction.getDirectionById(rand.nextInt(6));
                 TilePos randomPos = tilePos.add(rDir, new TilePos());
                 if (canMossSpread(world, randomPos)) {
-                    Block<?> mossStone = getMossBlock(world.getBlockId(randomPos));
+                    @Nullable Block<?> mossStone = getMossBlock(world.getBlockType(randomPos));
                     if (mossStone != null) {
-                        world.setBlockIdNotify(randomPos, mossStone.id());
+                        world.setBlockTypeNotify(randomPos, mossStone);
                     }
                 }
             }
@@ -69,42 +69,34 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
         return maxBlockLight == 0 && maxSkyLight == 0;
     }
 
-    public static @Nullable Block<?> getMossBlock(int blockId) {
-        return getMossBlock(Blocks.getBlock(blockId));
+    public static @Nullable Block<?> getMossBlock(final @NotNull Block<?> noMossBlock) {
+        return NO_MOSS_TO_MOSS_MAP.get(noMossBlock);
     }
 
-    public static @Nullable Block<?> getMossBlock(@Nullable Block<?> stoneBlock) {
-        return stoneToMossMap.get(stoneBlock);
+    public static @Nullable Block<?> getNoMossBlock(final @NotNull Block<?> mossBlock) {
+        return MOSS_TO_NO_MOSS_MAP.get(mossBlock);
     }
 
-    public static @Nullable Block<?> getStoneBlock(final int blockId) {
-        return getStoneBlock(Blocks.getBlock(blockId));
-    }
-
-    public static @Nullable Block<?> getStoneBlock(@Nullable Block<?> mossBlock) {
-        return mossToStoneMap.get(mossBlock);
-    }
-
-    public static final @NotNull Map<@NotNull Block<?>, @NotNull Block<?>> stoneToMossMap = new HashMap<>();
-    public static final @NotNull Map<@NotNull Block<?>, @NotNull Block<?>> mossToStoneMap = new HashMap<>();
+    public static final @NotNull Map<@NotNull Block<?>, @NotNull Block<?>> NO_MOSS_TO_MOSS_MAP = new HashMap<>();
+    public static final @NotNull Map<@NotNull Block<?>, @NotNull Block<?>> MOSS_TO_NO_MOSS_MAP = new HashMap<>();
 
     public static void initMossMap() {
-        stoneToMossMap.clear();
-        mossToStoneMap.clear();
-
-        stoneToMossMap.put(Blocks.STONE, Blocks.MOSS_STONE);
-        stoneToMossMap.put(Blocks.GRANITE, Blocks.MOSS_GRANITE);
-        stoneToMossMap.put(Blocks.LIMESTONE, Blocks.MOSS_LIMESTONE);
-        stoneToMossMap.put(Blocks.BASALT, Blocks.MOSS_BASALT);
-        stoneToMossMap.put(Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY);
-        stoneToMossMap.put(Blocks.COBBLE_BASALT, Blocks.COBBLE_BASALT_MOSSY);
-        stoneToMossMap.put(Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_LIMESTONE_MOSSY);
-        stoneToMossMap.put(Blocks.COBBLE_GRANITE, Blocks.COBBLE_GRANITE_MOSSY);
-        stoneToMossMap.put(Blocks.BRICK_STONE_POLISHED, Blocks.BRICK_STONE_POLISHED_MOSSY);
-        stoneToMossMap.put(Blocks.LOG_OAK, Blocks.LOG_OAK_MOSSY);
-
-        for (Entry<Block<?>, Block<?>> entry : stoneToMossMap.entrySet()) {
-            mossToStoneMap.put(entry.getValue(), entry.getKey());
+        NO_MOSS_TO_MOSS_MAP.clear();
+        MOSS_TO_NO_MOSS_MAP.clear();
+
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.STONE, Blocks.MOSS_STONE);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.GRANITE, Blocks.MOSS_GRANITE);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.LIMESTONE, Blocks.MOSS_LIMESTONE);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.BASALT, Blocks.MOSS_BASALT);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.COBBLE_BASALT, Blocks.COBBLE_BASALT_MOSSY);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_LIMESTONE_MOSSY);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.COBBLE_GRANITE, Blocks.COBBLE_GRANITE_MOSSY);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.BRICK_STONE_POLISHED, Blocks.BRICK_STONE_POLISHED_MOSSY);
+        NO_MOSS_TO_MOSS_MAP.put(Blocks.LOG_OAK, Blocks.LOG_OAK_MOSSY);
+
+        for (Entry<Block<?>, Block<?>> entry : NO_MOSS_TO_MOSS_MAP.entrySet()) {
+            MOSS_TO_NO_MOSS_MAP.put(entry.getValue(), entry.getKey());
         }
     }
 
@@ -131,9 +123,9 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
                     continue;
                 }
 
-                Block<?> block = getMossBlock(world.getBlockId(randomPos));
+                @Nullable Block<?> block = getMossBlock(world.getBlockType(randomPos));
                 if (block != null) {
-                    world.setBlockIdNotify(randomPos, block.id());
+                    world.setBlockTypeNotify(randomPos, block);
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
index f207de2c9..2adfb8081 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
@@ -31,7 +31,7 @@ public class BlockLogicMud extends BlockLogic {
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     private boolean isWaterNearby(final @NotNull World world, final @NotNull TilePosc tilePos, int range) {
@@ -39,7 +39,7 @@ public class BlockLogicMud extends BlockLogic {
         for (queryPos.x = tilePos.x() - range; queryPos.x <= tilePos.x() + range; queryPos.x++) {
             for (queryPos.y = tilePos.y() - range; queryPos.y <= tilePos.y() + range; queryPos.y++) {
                 for (queryPos.z = tilePos.z() - range; queryPos.z <= tilePos.z() + range; queryPos.z++) {
-                    if (Blocks.hasTag(world.getBlockId(queryPos), BlockTags.IS_WATER)) {
+                    if (world.getBlockType(queryPos).hasTag(BlockTags.IS_WATER)) {
                         return true;
                     }
                 }
@@ -54,7 +54,7 @@ public class BlockLogicMud extends BlockLogic {
         for (queryPos.x = tilePos.x() - 1; queryPos.x <= tilePos.x() + 1; queryPos.x++) {
             for (queryPos.y = tilePos.y() - 1; queryPos.y <= tilePos.y() + 1; queryPos.y++) {
                 for (queryPos.z = tilePos.z() - 1; queryPos.z <= tilePos.z() + 1; queryPos.z++) {
-                    if (Blocks.hasTag(world.getBlockId(queryPos), BlockTags.IS_LAVA)) {
+                    if (world.getBlockType(queryPos).hasTag(BlockTags.IS_LAVA)) {
                         return true;
                     }
                 }
@@ -76,8 +76,8 @@ public class BlockLogicMud extends BlockLogic {
                 for (queryPos.y = tilePos.y() - 1; queryPos.y <= tilePos.y() + 1; queryPos.y++) {
                     for (queryPos.z = tilePos.z() - 1; queryPos.z <= tilePos.z() + 1; queryPos.z++) {
                         //...And the block is next to another wet mud block, it can become wet
-                        int bID = world.getBlockId(queryPos);
-                        if (bID == Blocks.MUD.id() || (bID == Blocks.FARMLAND_DIRT.id() && BlockLogicFarmland.isWet(world.getBlockData(queryPos)))) {
+                        final @NotNull Block<?> block = world.getBlockType(queryPos);
+                        if (block == Blocks.MUD || (block == Blocks.FARMLAND_DIRT && BlockLogicFarmland.isWet(world.getBlockData(queryPos)))) {
                             return true;
                         }
                     }
@@ -88,8 +88,8 @@ public class BlockLogicMud extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
-        world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     @Override
@@ -98,7 +98,7 @@ public class BlockLogicMud extends BlockLogic {
     }
 
     private void tryToFall(@NotNull World world, @NotNull TilePosc tilePos) {
-        if (world.getBlockId(tilePos) == Blocks.MUD_BAKED.id()) {
+        if (world.getBlockType(tilePos) == Blocks.MUD_BAKED) {
             return;
         }
 
@@ -106,7 +106,7 @@ public class BlockLogicMud extends BlockLogic {
         if (canFallBelow(world, tilePos.down(queryPos)) && tilePos.y() >= 0) {
             byte radius = 32;
             if (!world.areBlocksLoaded(tilePos.add(-radius, -radius, -radius, new TilePos()), tilePos.add(radius, radius, radius, new TilePos()))) {
-                world.setBlockIdNotify(tilePos, 0);
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
 
                 int checkX = tilePos.x();
                 int checkY = tilePos.y() - 1;
@@ -115,7 +115,7 @@ public class BlockLogicMud extends BlockLogic {
                     checkY--;
                 }
                 if (checkY > 0) {
-                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
+                    world.setBlockTypeNotify(queryPos.set(checkX, checkY, checkZ), this.block);
 
                 }
             } else {
@@ -126,8 +126,8 @@ public class BlockLogicMud extends BlockLogic {
     }
 
     public static boolean canFallBelow(@NotNull World world, @NotNull TilePos tilePos) {
-        int blockId = world.getBlockId(tilePos);
-        return blockId == 0 || blockId == Blocks.FIRE.id() || Blocks.hasTag(blockId, BlockTags.IS_WATER) || Blocks.hasTag(blockId, BlockTags.IS_LAVA);
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+        return block == Blocks.AIR || block == Blocks.FIRE || block.hasTag(BlockTags.IS_WATER) || block.hasTag(BlockTags.IS_LAVA);
     }
 
 
@@ -137,8 +137,8 @@ public class BlockLogicMud extends BlockLogic {
         if (this.isHardened) {
             if (!isLavaNearby(world, tilePos)) {
                 if (canBecomeWet(world, tilePos)) {
-                    world.setBlockId(tilePos, Blocks.MUD.id());
-                    world.notifyBlockChange(tilePos, Blocks.MUD.id());
+                    world.setBlockType(tilePos, Blocks.MUD);
+                    world.notifyBlockChange(tilePos, Blocks.MUD);
                     return;
                 }
             }
@@ -151,8 +151,8 @@ public class BlockLogicMud extends BlockLogic {
                 for (int l = 0; l < 8; l++) {
                     world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
                 }
-                world.setBlockId(tilePos, Blocks.MUD_BAKED.id());
-                world.notifyBlockChange(tilePos, Blocks.MUD_BAKED.id());
+                world.setBlockType(tilePos, Blocks.MUD_BAKED);
+                world.notifyBlockChange(tilePos, Blocks.MUD_BAKED);
                 return;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
index 21235eedd..efe3b95a1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
@@ -27,15 +27,15 @@ public class BlockLogicMushroom extends BlockLogicFlower {
             if (world.isAirBlock(checkPos) && canStay(world, checkPos)) {
                 checkPos.set(tilePos.x() + rand.nextInt(3) - 1, checkPos.y, tilePos.z() + rand.nextInt(3) - 1);
                 if (world.isAirBlock(checkPos) && canStay(world, checkPos)) {
-                    world.setBlockIdNotify(checkPos, this.block.id());
+                    world.setBlockTypeNotify(checkPos, this.block);
                 }
             }
         }
     }
 
     @Override
-    protected boolean mayPlaceOn(int blockId) {
-        return Blocks.solid[blockId];
+    protected boolean mayPlaceOn(final @NotNull Block<?> block) {
+        return block.solid();
     }
 
     @Override
@@ -43,7 +43,7 @@ public class BlockLogicMushroom extends BlockLogicFlower {
         if (tilePos.y() < 0 || tilePos.y() >= world.getHeightBlocks()) {
             return false;
         } else {
-            return world.getFullBlockLightValue(tilePos) < 13 && mayPlaceOn(world.getBlockId(tilePos.down(new TilePos())));
+            return world.getFullBlockLightValue(tilePos) < 13 && mayPlaceOn(world.getBlockType(tilePos.down(new TilePos())));
         }
     }
 
@@ -65,16 +65,16 @@ public class BlockLogicMushroom extends BlockLogicFlower {
                     checkX += rand.nextInt(3) - 1;
                     checkY += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
                     checkZ += rand.nextInt(3) - 1;
-                    if (world.getFullBlockLightValue(queryPos.set(checkX, checkY, checkZ)) >= 13 || !mayPlaceOn(world.getBlockId(queryPos.set(checkX, checkY - 1, checkZ)))) {
+                    if (world.getFullBlockLightValue(queryPos.set(checkX, checkY, checkZ)) >= 13 || !mayPlaceOn(world.getBlockType(queryPos.set(checkX, checkY - 1, checkZ)))) {
                         continue outer;
                     }
                 }
 
-                if (world.getBlockId(queryPos.set(checkX, checkY, checkZ)) != 0) {
+                if (world.getBlockType(queryPos.set(checkX, checkY, checkZ)) != Blocks.AIR) {
                     continue;
                 }
                 if (rand.nextFloat() > 0.85) {
-                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
+                    world.setBlockTypeNotify(queryPos.set(checkX, checkY, checkZ), this.block);
                 }
             }
             return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
index eb01c7bd0..f5d14676d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
@@ -40,20 +40,20 @@ public class BlockLogicNetherrackIgneous extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
-        world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
     }
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
     }
 
     public boolean canMelt(@NotNull World world, @NotNull TilePosc tilePos) {
         boolean canMelt = false;
         TilePos queryPos = new TilePos();
         for (Direction dir : Direction.directions) {
-            Block<?> block = world.getBlock(tilePos.add(dir, queryPos));
+            Block<?> block = world.getBlockType(tilePos.add(dir, queryPos));
             Material adjacentMaterial = block == null ? Materials.AIR : block.getMaterial();
             if (adjacentMaterial == Materials.WATER) {
                 return false;
@@ -66,7 +66,7 @@ public class BlockLogicNetherrackIgneous extends BlockLogic {
     @Override
     public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         if (canMelt(world, tilePos)) {
-            world.setBlockIdNotify(tilePos, Blocks.FLUID_LAVA_FLOWING.id());
+            world.setBlockTypeNotify(tilePos, Blocks.FLUID_LAVA_FLOWING);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
index c5d2d7fcd..2b18f377e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
@@ -31,7 +31,7 @@ public class BlockLogicNote extends BlockLogic {
 
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         boolean powered = world.hasNeighborSignal(tilePos);
         int data = world.getBlockData(tilePos);
         if (isPowered(data) && !powered) {
@@ -73,7 +73,7 @@ public class BlockLogicNote extends BlockLogic {
         if (world.isBlockOpaqueCube(tilePos.up(new TilePos()))) {
             return;
         }
-        world.triggerEvent(tilePos, Instrument.getInstrumentFromBlock(world.getBlock(tilePos.down(new TilePos()))).index, getNote(world.getBlockData(tilePos)));
+        world.triggerEvent(tilePos, Instrument.getInstrumentFromBlock(world.getBlockType(tilePos.down(new TilePos()))).index, getNote(world.getBlockData(tilePos)));
     }
 
     public static int setNote(int data, int note) {
